<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="员工名称" prop="staffName">
        <el-input
          v-model="queryParams.staffName"
          placeholder="请输入员工名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="班组名称" prop="groupId">
        <el-select v-model="queryParams.groupId" placeholder="请选择班组名称" clearable>
          <el-option
            v-for="item in teamMembersList"
            :key="item.teamCode"
            :label="item.teamName"
            :value="item.teamCode"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="事件日期">
        <el-date-picker
          v-model="daterangeEventDate"
          style="width: 240px"
          value-format="yyyy-MM-dd"
          type="daterange"
          range-separator="-"
          start-placeholder="开始时间"
          end-placeholder="结束时间"
        ></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="primary"-->
      <!--          plain-->
      <!--          icon="el-icon-plus"-->
      <!--          size="mini"-->
      <!--          @click="handleAdd"-->
      <!--          v-hasPermi="['mes/record:recordStaffSalary:add']"-->
      <!--        >新增-->
      <!--        </el-button>-->
      <!--      </el-col>-->
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="success"-->
      <!--          plain-->
      <!--          icon="el-icon-edit"-->
      <!--          size="mini"-->
      <!--          :disabled="single"-->
      <!--          @click="handleUpdate"-->
      <!--          v-hasPermi="['mes/record:recordStaffSalary:edit']"-->
      <!--        >修改-->
      <!--        </el-button>-->
      <!--      </el-col>-->
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="danger"-->
      <!--          plain-->
      <!--          icon="el-icon-delete"-->
      <!--          size="mini"-->
      <!--          :disabled="multiple"-->
      <!--          @click="handleDelete"-->
      <!--          v-hasPermi="['mes/record:recordStaffSalary:remove']"-->
      <!--        >删除-->
      <!--        </el-button>-->
      <!--      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['mes/record:recordStaffSalary:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="recordStaffSalaryList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="主键标识" align="center" prop="objId" v-if="columns[0].visible"/>
      <el-table-column label="员工编号" align="center" prop="staffId" v-if="columns[1].visible"/>
      <el-table-column label="员工名称" align="center" prop="staffName" v-if="columns[2].visible"/>
      <el-table-column label="身份证" align="center" prop="idCard" v-if="columns[3].visible" width="200"/>
      <el-table-column label="班组名称" align="center" prop="teamName" v-if="columns[5].visible" width="230"/>
      <el-table-column label="收入金额" align="center" prop="revenueAmount" v-if="columns[4].visible"/>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import {
  listSalarySummaryReport
} from '@/api/mes/record/recordStaffSalary'
import { getTeamMembers } from '@/api/mes/base/baseTeamMembers'
import { parseTime } from '@/utils/ruoyi'

export default {
  name: 'SalarySummaryReport',
  dicts: ['is_erp'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 员工工资记录表格数据
      recordStaffSalaryList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 结束日期时间范围
      daterangeEventDate: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        idCard: null,
        groupId: null,
        eventDate: null,
        salaryCategory: null,
        revenueClass: null,
        revenueAmount: null,
        revenueReason: null,
        fineClass: null,
        fineAmount: null,
        fineReason: null,
        taskCode: null,
        salaryCoefficient: null,
        beginDate: null,
        endDate: null,
        isErp: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        objId: [
          { required: true, message: '主键标识不能为空', trigger: 'blur' }
        ]
      },
      columns: [
        { key: 0, label: `主键标识`, visible: false },
        { key: 1, label: `员工编号`, visible: true },
        { key: 2, label: `员工名称`, visible: true },
        { key: 3, label: `身份证`, visible: true },
        { key: 4, label: `收入金额`, visible: true },
        { key: 5, label: `班组名称`, visible: true },
      ],
      // 班组选项
      teamMembersList: []
    }
  },
  created() {
    const currentDate = new Date()
    const firstDay = parseTime(new Date(currentDate.getFullYear(), currentDate.getMonth(), 1), '{y}-{m}-{d}')
    const lastDay = parseTime(new Date(currentDate.getFullYear(), currentDate.getMonth() + 1, 0), '{y}-{m}-{d}')
    this.daterangeEventDate[0] = firstDay
    this.daterangeEventDate[1] = lastDay
    getTeamMembers().then(response => {
      this.teamMembersList = response.data
    })
    this.getList()
  },
  methods: {
    /** 查询员工工资记录列表 */
    getList() {
      this.loading = true
      this.queryParams.params = {}
      if (null != this.daterangeEventDate && '' != this.daterangeEventDate) {
        this.queryParams.beginEventDate = this.daterangeEventDate[0]
        this.queryParams.endEventDate = this.daterangeEventDate[1]
      }
      listSalarySummaryReport(this.queryParams).then(response => {
        this.recordStaffSalaryList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        objId: null,
        idCard: null,
        groupId: null,
        eventDate: null,
        salaryCategory: null,
        revenueClass: null,
        revenueAmount: null,
        revenueReason: null,
        fineClass: null,
        fineAmount: null,
        fineReason: null,
        createTime: null,
        taskCode: null,
        salaryCoefficient: null,
        beginDate: null,
        endDate: null
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeEventDate = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.objId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加员工工资记录'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const objId = row.objId || this.ids
      getRecordStaffSalary(objId).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改员工工资记录'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.objId != null) {
            updateRecordStaffSalary(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addRecordStaffSalary(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const objIds = row.objId || this.ids
      this.$modal.confirm('是否确认删除员工工资记录编号为"' + objIds + '"的数据项？').then(function() {
        return delRecordStaffSalary(objIds)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('删除成功')
      }).catch(() => {
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('mes/boardPort/salarySummaryReport/export', {
        ...this.queryParams
      }, `员工工资汇总报表_${new Date().getTime()}.xlsx`)
    }
  }
}
</script>
